﻿<%@ Page Title="" Language="C#" MasterPageFile="~/PMTSite.Master" AutoEventWireup="true" CodeBehind="ActGantt.aspx.cs" Inherits="ProjectManagementTool.ActGantt" %>

<%@ Register Assembly="Syncfusion.EJ.Web, Version=13.3450.0.7, Culture=neutral, PublicKeyToken=3d67ed1f87d44c89" Namespace="Syncfusion.JavaScript.Web" TagPrefix="ej" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="chpMobileMenu" runat="server">
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="cphMainContent" runat="server">
    <style>
        div.rfMid table { display: inline !important; width: 300px; font-size: smaller; }

        div#Gantt1 table { margin-bottom: auto; }

        #Gantt1AddForm table, #Gantt1EditForm table { border: none; }

            #Gantt1AddForm table tr.even, #Gantt1AddForm table tr.alt, #Gantt1AddForm table tr:nth-of-type(2n), #Gantt1EditForm table tr.even, #Gantt1EditForm table tr.alt, #Gantt1EditForm table tr:nth-of-type(2n) { background-color: #fff !important; }

        #Gantt1_dialogEdit_wrapper { width: 550px !important; }

        #Gantt1AddForm table tr th, #Gantt1AddForm table tr td, #Gantt1EditForm table tr th, #Gantt1EditForm table tr td { padding: 0 15px !important; }

        #Gantt1_dialogEdit { padding-left: 0 !important; padding-right: 0 !important; }
    </style>
    <asp:ScriptManager ID="ScriptManager1" runat="server" EnablePageMethods="True"></asp:ScriptManager>
    <telerik:RadTabStrip ID="RadTabStrip1" runat="server" MultiPageID="RadMultiPage1" SelectedIndex="0">
        <Tabs>
            <telerik:RadTab Text="Project Info" Width="120px" NavigateUrl="AddProjectTask.aspx?PV=0"></telerik:RadTab>
            <telerik:RadTab Text="Stake Holders" Width="140px" NavigateUrl="AddProjectTask.aspx?PV=1"></telerik:RadTab>
            <telerik:RadTab runat="server" Text="Activities" NavigateUrl="ActGantt.aspx" Selected="True"></telerik:RadTab>
            <telerik:RadTab Text="Objectives" Width="120px" NavigateUrl="Objectives.aspx"></telerik:RadTab>
            <telerik:RadTab Text="Stage Gates" Width="120px" NavigateUrl="StageGates.aspx"></telerik:RadTab>
            <telerik:RadTab Text="Risks" Width="120px" NavigateUrl="Risks.aspx" Selected="True"></telerik:RadTab>
        </Tabs>
    </telerik:RadTabStrip>
    
    <% if (Session["ProjectTaskType"].ToString().ToLower() != "-1")
       { %>
    <table style="width: 100%">
        <tr>
            <td style="width: 15%; background-color: #008aab; color: White;">
                <strong><%= Session["ProjectTaskType"].ToString()=="0" ? "Project Id:" : "Task Id:" %> </strong>&nbsp; <%=ProjId%>
            </td>

            <td style="width: 85%; background-color: #008aab; color: White;">
                <strong><%= Session["ProjectTaskType"].ToString()=="0" ? "Project Name:" : "Task Name:" %> </strong>&nbsp; <%=ProjName%>
            </td>

            <td style="width: 85%; background-color: #008aab; color: White;">
                <asp:Label ID="lblComp" Font-Bold="true" Font-Italic="true" Text='' runat="server"></asp:Label>
            </td>
        </tr>
    </table>
    <% } %>
    <div>
        <ej:gantt id="Gantt1" runat="server"
            tasknamemapping="TaskName"
            taskidmapping="TaskId"
            parenttaskidmapping="ParentId"
            startdatemapping="StartDate"
            enddatemapping="EndDate"
            durationmapping="Duration"
            showcolumnchooser="true"
            predecessormapping="Predecessor" progressmapping="Progress"
            childmapping="Children"
            treecolumnindex="1"
            splitterposition="99%"
            enablecontextmenu="true"
            allowcolumnresize="true"
            allowsorting="true"
            includeweekend="false" highlightweekends="true" load="load" actionbegin="actionBegin" actioncomplete="actionComplete" clientidmode="Static">
            <EditSettings AllowAdding="true" AllowDeleting="true" AllowEditing="true" EditMode="cellEditing" />
            <ToolbarSettings ShowToolbar="true" ToolbarItems="add,edit,delete,indent,outdent,collapseAll,expandAll" />             
        </ej:gantt>
        <%--Column template for check box column--%>
        <script type="text/x-jsrender" id="investigateColumnTemplate1">
            <div style="margin-left: 20px;">
                {{if Investigate}}
                    <input class="customCheckbox" type="checkbox" disabled="disabled" checked="checked" value="" />{{else}}
                    <input class="customCheckbox" type="checkbox" disabled="disabled" value="" />{{/if}}
            </div>
            
        </script>

        <script>

            $(function () {
                $('#Gantt1').ejGantt({
                    holidays: [{
                        day: '10/7/2015',
                        label: 'public holiday',
                        background: 'yellowblue'
                    },
                    {
                        day: '11/11/2015',
                        label: 'my holiday',
                        background: 'yellowgreen'
                    }]
                });
            });


            function load(args) {
                var obj = $("#Gantt1").data("ejGantt");
                var columns = obj.getColumns();
                debugger;


                // get Teams
                $.ajax({
                    type: 'GET',
                    url: '<%= ResolveClientUrl("~/ActGantt.aspx/GetTeams") %>',
                    data: {},
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    success: function (result) {
                        var teamCol = columns[10];
                        columns.splice(10, 1);
                        columns.splice(10, 0, teamCol)
                        columns[10].dropdownData = result.d;
                    },
                    error: function (msg) {
                        var data = eval("(" + msg.d + ")");
                        alert(msg.d);
                    }
                });

                // get Roles
                $.ajax({
                    type: 'GET',
                    url: '<%= ResolveClientUrl("~/ActGantt.aspx/GetRoles") %>',
                    data: {},
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    success: function (result) {
                        columns[11].dropdownData = result.d;
                    },
                    error: function (msg) {
                        var data = eval("(" + msg.d + ")");
                        alert(msg.d);
                    }
                });



                // get Resources
                $.ajax({
                    type: 'GET',
                    url: '<%= ResolveClientUrl("~/ActGantt.aspx/GetResources") %>',
                        data: {},
                        contentType: 'application/json; charset=utf-8',
                        dataType: 'json',
                        success: function (result) {
                            columns[6].dropdownData = result.d;
                        },
                        error: function (msg) {
                            var data = eval("(" + msg.d + ")");
                            alert(msg.d);
                        }
                   });


                // get Statuses
                    $.ajax({
                        type: 'GET',
                        url: '<%= ResolveClientUrl("~/ActGantt.aspx/GetStatuses") %>',
                        data: {},
                        contentType: 'application/json; charset=utf-8',
                        dataType: 'json',
                        success: function (result) {
                            columns[12].dropdownData = result.d;
                        },
                        error: function (msg) {
                            var data = eval("(" + msg.d + ")");
                            alert(msg.d);
                        }
                    });

                // duration
                    var column4 = columns[4];
                    columns.splice(4, 1);
                    columns.splice(4, 0, column4);

                //Progress
                    var column5 = columns[5];
                    columns.splice(7, 1);
                    columns.splice(7, 0, column5);

                // Predecessor
                    var column6 = columns[6];
                    columns.splice(5, 1);
                    columns.splice(5, 0, column6);

                // resource
                    var resourceCol = columns[6];
                    columns.splice(6, 1);
                    columns.splice(6, 0, resourceCol)
                    columns.splice(6, 0, {
                        field: "ResourceId",
                        headerText: "Resource",
                        mappingName: "ResourceId",
                        editType: "dropdownedit",
                        dropdownData: null,
                        editParams: { fields: { text: "ResourceName", value: "ResourceId" } },
                        width: "90px"
                    });

                    columns.splice(10, 0, {
                        field: "TeamId",
                        headerText: "Team",
                        mappingName: "TeamId",
                        editType: "dropdownedit",
                        dropdownData: null,
                        editParams: { fields: { text: "TeamName", value: "TeamId" } },
                        width: "50px"
                    });

                    columns.splice(11, 0, {
                        field: "RoleId",
                        headerText: "Role",
                        mappingName: "RoleId",
                        editType: "dropdownedit",
                        dropdownData: null,
                        editParams: { fields: { text: "RoleName", value: "RoleId" } },
                        width: "90px"
                    });



                    columns.splice(12, 0, {
                        field: "Status",
                        headerText: "Status",
                        mappingName: "StatusId",
                        editType: "dropdownedit",
                        dropdownData: null,
                        editParams: { fields: { text: "StatusName", value: "StatusId" } },
                        width: "90px"
                    });

                    columns.splice(13, 0, {
                        field: "EstimatedManHours",
                        headerText: "Est.ManHrs",
                        mappingName: "EstManHours",
                        editType: "stringedit",
                        width: "110px"
                    });

                // investigate checkbox here - custom field
                    columns.splice(14, 0, {
                        field: "Investigate",
                        headerText: "Investigate",
                        mappingName: "Investigate",
                        editType: "booleanedit",
                        isTemplateColumn: true,
                        templateID: "investigateColumnTemplate1",
                        width: "110px"
                    });




                }

                function actionBegin(args) {
                    if (args.isTrigger === 3 && args.requestType === 'delete') {
                        if (!confirm("Are you sure you want to delete this record?")) {
                            args.cancel = true;
                        }
                    }
                }


                function actionComplete(args) {
                    //  var ganttObj = $("#Gantt1").data("ejGantt");

                    if (args.requestType === 'save' && args.addedRecord) {
                        //Newly Added Record is obtained here , which can be updated to database
                        var ganttRecord = args.addedRecord.item;

                        if (ganttRecord.TeamId == "") {
                            ganttRecord.TeamId = 0;
                        }
                        if (ganttRecord.RoleId == "") {
                            ganttRecord.RoleId = 0;
                        }
                        if (ganttRecord.ResourceId == "") {
                            ganttRecord.ResourceId = 0;
                        }
                        if (ganttRecord.StatusId == "") {
                            ganttRecord.StatusId = 0;
                        }
                        if (ganttRecord.EstManHours == "") {
                            ganttRecord.EstManHours = 0;
                        }

                        if (args.addedRecord.parentItem)
                            ganttRecord["ParentId"] = args.addedRecord.parentItem.taskId;
                        PageMethods.AddIt(ganttRecord);
                    }
                    else if (args.requestType === 'delete') {
                        var data = args.data;
                        var ganttRec = data.item;

                        //Logic to delete the item
                        PageMethods.DeleteIt(ganttRec);

                        if (data.hasChildRecords) {
                            deleteChildRecords(data);
                        }
                    }
                        // To update the database during Outdent,editing,indent,predecessor update operation
                    else if (args.requestType === 'outdent' || args.requestType === 'recordUpdate') {

                        var ganttRec = args.data.item;

                        if (ganttRec.ParentId === null) {
                            ganttRec.ParentId = 0;
                        }

                        if (ganttRec.TeamId == "") {
                            ganttRec.TeamId = 0;
                        }
                        if (ganttRec.RoleId == "") {
                            ganttRec.RoleId = 0;
                        }
                        if (ganttRec.ResourceId == "") {
                            ganttRec.ResourceId = 0;
                        }
                        if (ganttRec.StatusId == "") {
                            ganttRec.StatusId = 0;
                        }
                        if (ganttRec.EstManHours == "") {
                            ganttRec.EstManHours = 0;
                        }

                        PageMethods.UpdateIt(ganttRec);
                    }
                }

                //Delete inner level child records
                function deleteChildRecords(record) {
                    var childRecords = record.childRecords,
                        length = childRecords.length,
                        count, currentRecord;
                    for (count = 0; count < length; count++) {
                        currentRecord = childRecords[count];
                        PageMethods.DeleteIt(currentRecord.item);
                        if (currentRecord.hasChildRecords) {
                            deleteChildRecords(currentRecord);
                        }
                    }
                }
        </script>
    </div>

</asp:Content>
<asp:Content ID="Content4" ContentPlaceHolderID="cphFooterContent" runat="server">
</asp:Content>
